/******************************************************************************
 *
 *     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
 *     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
 *     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
 *     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
 *     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
 *     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
 *     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
 *     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
 *     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
 *     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
 *     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
 *     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *     FOR A PARTICULAR PURPOSE.
 *     
 *     (c) Copyright 2005 Xilinx, Inc.
 *     All rights reserved.
 *
 ******************************************************************************/

//----------------------------------------------------------------------------
// Filename:		gpio_lcd_led.c
// 
// Description:		Routines for LCD and LED 
//
// Design Notes:
//   
//-----------------------------------------------------------------------------
// Xilinx APD
// History:
//
//-----------------------------------------------------------------------------

#define USE_IO_MACROS
#include "xio.h"
#include "xparameters.h"
#include "xgpio_l.h"

// const XIo_Address LCD_PORT = XPAR_LCD_7BIT_GPIO_BASEADDR;		// LCD Port

// // LCD parameters 
// #define lcd_buf_size 80		// buffer size of the LCD display
// #define DSP_SET (0x28)		// b000101000 function set, 4 bit, 2 line, 5x7
// #define DSP_SET8 (0x38)		// b000111000 function set, 8 bit, 2 line, 5x7
// #define DSP_ON  (0x0c)		// b000001100 display on, cursor off, blink off
// #define DSP_MD  (0x06)		// b000000110 entry mode, increment, no shift
// #define DSP_ADR (0x80)		// b010000000 set address to zero
// #define DSP_CLR (0x01)		// b000000001 clear display
// #define SWITCH_MASK   0x00000007

// void init_GPIO(void)
// {
//    XGpio_mSetDataDirection(LCD_PORT, 1, 0x00000000);   /* Set LED port as outputs */
// }

// // write to LCD
// void GPIO_writeLCD( Xuint32 data )
// {
// 	XIo_Out32((XIo_Address)LCD_PORT, data); // write LCD bits
// 	} 

// // low level LCD driver to output a single nibble
// void lcd_nibble_out (int code) 
// {
// 	// delay 50 usec between writes
// 	// present data to the display
// 	GPIO_writeLCD (code); usleep (50);
// 	// raise the enable line
// 	GPIO_writeLCD (code | 0x20 ); usleep (50);
// 	// lower enable line
// 	GPIO_writeLCD (code); usleep (50);
// 	}

// // output a command consisting of two nibbles
// void lcd_out(int code)
// {
	
// 	lcd_nibble_out(code >> 4);
// 	lcd_nibble_out(code & 0x0F);
// }

// // output an ASCII character consisting of two nibbles
// void lcd_out_char(int code)
// {
	
// 	lcd_nibble_out((code >> 4) | 0x10);
// 	lcd_nibble_out((code & 0x0F) | 0x10);
// }

// // initialize the LCD display
// void LCD_Init(void) 
// {
// 	int i;

// 	XGpio_mSetDataDirection((XIo_Address)LCD_PORT, 1, 0x00000000);   /* Program LCD port for output*/

// 	// delay 15ms after processor reset
// 	usleep (15000);
// 	// output Display Set 3 times with 50ms delay
// 	for (i=0; i < 3; i++)
// 		{ lcd_nibble_out (DSP_SET8 >> 4); usleep (50000); }
// 	// now force display to 4 bit mode
// 	lcd_nibble_out(DSP_SET >> 4); usleep (50000);
// 	// finally send out full display set command
// 	lcd_out (DSP_SET); usleep (50000);
// 	// clear the display
// 	lcd_out (DSP_CLR); usleep (50000);
// 	// turn display on
// 	lcd_out (DSP_ON); usleep (50000);
// 	// set display mode
// 	lcd_out (DSP_MD); usleep (50000);
// 	// set display address
// 	lcd_out (DSP_ADR); usleep (50000);
// 	}

// // write two strings to display
// void LCD_Write(char line1[], char line2[])
// {
//  	int buf[lcd_buf_size]; // display buffer (integer for easier conversion to 10 bits later)
// 	int i;
// 	int j;
// 	// clear the buffer
// 	for (i=0; i < lcd_buf_size; i++) buf[i] = ' ';
// 	// copy lines 1 and 2 to the buffer at locations zero and 40
// 	for (i=0; i < strlen(line1); i++) buf[i] = line1[i];
//  	for (i=0; i < strlen(line2); i++) buf[i+40] = line2[i];
// 	// set display address to zero
// 	lcd_out (DSP_ADR); usleep (5000);
// 	// low level write 80 characters to display
	
// 	for (i=0; i < lcd_buf_size; i++) {
// 		lcd_out_char(buf[i]); 
// 	}
// }

/*
 * Routine to write a pattern out to a GPIO
 * which is configured as an output
 *   PARAMETER C_ALL_INPUTS = 0
 */ 
void WriteToGPOutput(Xuint32 BaseAddress, int gpio_width) 
{
   int i;
   volatile int delay;
   int numTimes = 4;
 
   XGpio_mSetDataDirection(BaseAddress, 1, 0x00000000);   /* Set as outputs */
   while (numTimes > 0) 
   {
      for(i=0; i<(gpio_width); i++) 
	  {
         XGpio_mSetDataReg(BaseAddress, 1, 1 << i);
         for (delay=0; delay<1000000; delay++);  //wait
      }
      numTimes--;
   }
}
